/***************************************************************
From the book "Motif Programming, The Essentials...and More"
by Marshall Brain.
Published by Digital Press, ISBN 1-55558-089-0.
To order the book, call 1-800-DIGITAL and ask for EY-J816E-DP.

Copyright 1992, by Digital Equipment Corp.

This code demonstrates the list widget.
***************************************************************/

/*list.c*/

#include <Xm/Xm.h>
#include <Xm/List.h>

XtAppContext context;
XmStringCharSet char_set=XmSTRING_DEFAULT_CHARSET;

Widget toplevel, list;
char *animals[]={"cat","dog","cow","goat","horse","mouse","pig",
                 "sheep","rat","donkey","elephant","squirrel"};

void selectCB(w,client_data,call_data)
    Widget w;
    XtPointer client_data;
    XmAnyCallbackStruct *call_data;
{
    int *pos_list;
    int pos_list_length;
    int x, *p;
    int mem_allocated;

    mem_allocated = XmListGetSelectedPos(list,&pos_list,&pos_list_length); 
    p=pos_list;
    for (x=0; x<pos_list_length; x++)
        printf("%d ",*p++);
    printf("\n");
    if (mem_allocated)
        XtFree(pos_list);    
}

void add_items()
{
    XmString s;
    int list_cnt;

    for (list_cnt=0; list_cnt<XtNumber(animals); list_cnt++)
    {
        s = XmStringCreate(animals[list_cnt], char_set);
        XmListAddItem(list,s,0);
        XmStringFree(s);
    }
}

void main(argc,argv)
    int argc;
    char *argv[];
{
    Arg al[20];
    int ac;

    /* create the toplevel shell */
    toplevel = XtAppInitialize(&context,"",NULL,0,&argc,argv,NULL,NULL,0);

    /* set the default size of the window. */ 
    ac=0;
    XtSetArg(al[ac],XmNwidth,200); ac++;
    XtSetArg(al[ac],XmNheight,200); ac++;
    XtSetValues(toplevel,al,ac); 

    /* create a list widget */
    ac=0;
    XtSetArg(al[ac],XmNselectionPolicy,XmMULTIPLE_SELECT); ac++;
    list=XmCreateScrolledList(toplevel,"list",al,ac);
    XtManageChild(list);
    XtAddCallback (list, XmNmultipleSelectionCallback, selectCB, NULL);

    add_items();    

    XtRealizeWidget(toplevel);
    XtAppMainLoop(context);
}
