/***************************************************************
From the book "Motif Programming, The Essentials...and More"
by Marshall Brain.
Published by Digital Press, ISBN 1-55558-089-0.
To order the book, call 1-800-DIGITAL and ask for EY-J816E-DP.

Copyright 1992, by Digital Equipment Corp.

This code demonstrates the the creation of a second
shell widget.
***************************************************************/

/* new_shell.c*/

#include <Xm/Xm.h>
#include <Xm/Text.h>
#include <Xm/PushB.h>
#include <X11/Shell.h>

XtAppContext context;

Widget toplevel, button, text, shell;

void buttonCB(w,client_data,call_data)
    Widget w;
    caddr_t client_data;
    caddr_t call_data;
/* called whenever pushbutton is clicked. */
{
    Arg al[10];
    int ac;

    /* turn the button off. */
    XtSetSensitive(button,False);

    /* create a new shell */
    ac=0;
    XtSetArg(al[ac], XmNheight, 300);    ac++;
    XtSetArg(al[ac], XmNwidth, 300);    ac++;
    shell=XtAppCreateShell("Shell","Shell", applicationShellWidgetClass, 
        XtDisplay(toplevel), al, ac);

    /* create a text widget in the new shell. */
    ac=0;
    XtSetArg(al[ac],XmNeditMode,XmMULTI_LINE_EDIT); ac++;
    text=XmCreateText(shell,"text",al,ac);
    XtManageChild(text);

    XtRealizeWidget(shell); /* the new shell must be realized. */
}

void main(argc,argv)
    int argc;
    char *argv[];
{
    Arg al[10];
    int ac;

    /* create the toplevel shell */
    toplevel = XtAppInitialize(&context,"",NULL,0,&argc,argv,NULL,NULL,0);

    /* create a pushbutton widget. */
    ac=0;
    button=XmCreatePushButton(toplevel,"button",al,ac);
    XtManageChild(button);
    XtAddCallback(button, XmNactivateCallback, buttonCB, NULL);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(context);
}
